from csp import Constraint, CSP
from typing import Dict, List, Optional, Any

import json, sys, argparse, numpy as np

# --------------------------------------------------------------------------
class TaxisConstraint(Constraint):
    def __init__(self, variables: List) -> None:
        super().__init__(variables)

    def satisfied(self, assignment: Dict) -> bool:
        # fill your constraints here
        return True

# --------------------------------------------------------------------------
def load_input(file):
    if file == '-':
        data = json.load(sys.stdin)

    else:
        with open(file, 'r') as fp:
            data = json.load(fp)
    
    return data

# --------------------------------------------------------------------------
if __name__ == "__main__":
    # setup arguments
    parser = argparse.ArgumentParser()
    parser.add_argument('input_file', help="input_file, use '-' for standard input")
    args = parser.parse_args()

    # load data
    data = load_input(args.input_file)

    # prepare variables and their domains
    variables: List = None # <- list of hashable variables (e.g., strings)
    domains: Dict = None # <- dict of variable -> domain

    # ------------------------
    # Implement your code here
    # ------------------------

    # optionally implement MCV heuristic here
    #
    #

    # create CSP
    csp: CSP = CSP(variables, domains)
    csp.add_constraint(TaxisConstraint(variables))

    # find solution
    solution: Optional[Dict] = csp.backtracking_search()

    # print it out
    if solution is None:
        print("{}")
    else:
        print(json.dumps(solution))
